Skip to content
GitLab
Explore
Sign in
Register
Primary navigation
Search or go to…
Project
H
holi-notifications
Manage
Activity
Members
Labels
Plan
Issues
Issue boards
Milestones
Wiki
Code
Repository
Branches
Commits
Tags
Repository graph
Compare revisions
Snippets
Deploy
Releases
Package registry
Operate
Terraform modules
Analyze
Contributor analytics
Help
Help
Support
GitLab documentation
Compare GitLab plans
Community forum
Contribute to GitLab
Provide feedback
Keyboard shortcuts
?
Snippets
Groups
Projects
Show more breadcrumbs
app
holi-notifications
Commits
83bbf38d
Commit
83bbf38d
authored
6 months ago
by
Ole Langbehn
Browse files
Options
Downloads
Plain Diff
Merge branch 'main' into production
parents
2712342d
fcc3c287
No related branches found
Branches containing commit
Tags
release/1.35.0
Tags containing commit
No related merge requests found
Changes
3
Hide whitespace changes
Inline
Side-by-side
Showing
3 changed files
.gitignore
+1
-0
1 addition, 0 deletions
.gitignore
.gitlab-ci.yml
+7
-0
7 additions, 0 deletions
.gitlab-ci.yml
terraform/environments/scripts/destroy-env.sh
+29
-4
29 additions, 4 deletions
terraform/environments/scripts/destroy-env.sh
with
37 additions
and
4 deletions
.gitignore
+
1
−
0
View file @
83bbf38d
.envrc.local
coverage
terraform*.log
This diff is collapsed.
Click to expand it.
.gitlab-ci.yml
+
7
−
0
View file @
83bbf38d
...
...
@@ -121,6 +121,13 @@ review_destroy:
name
:
review/$CI_COMMIT_REF_SLUG
action
:
stop
dependencies
:
[]
# explicitly disable artifact usage
artifacts
:
paths
:
-
"
terraform/environments/crash.log"
# optional, only available in case of a crash/panic
-
"
terraform/environments/terraform-*.log"
# separate log for every step/command
name
:
"
${CI_JOB_NAME}_${CI_JOB_ID}"
when
:
on_failure
expire_in
:
1 week
script
:
# branch may have been deleted, so we clone and checkout main
-
git clone $CI_REPOSITORY_URL main-clone
...
...
This diff is collapsed.
Click to expand it.
terraform/environments/scripts/destroy-env.sh
+
29
−
4
View file @
83bbf38d
#!/usr/bin/env sh
#!/usr/bin/env
ba
sh
# exit when any command fails
set
-ex
...
...
@@ -6,11 +6,36 @@ set -ex
# enable debug output in terraform
export
TF_LOG
=
DEBUG
cd
terraform/environments
# retry logic for destroy: sometimes, a full workspace destroy does not work. This can be due to e.g.:
# * implicit dependencies between terraform resources not declared with depends_on,
# * unclean shutdown of resources, e.g. service does not close db connections, db still sees clients connected,
# * GCP stuff not allowing our resources to be deleted.
# Most of the time, retrying a destroy fixes these causes.
retry
()
{
for
i
in
{
1..3
}
;
do
set
+e
"
$@
"
retval
=
$?
set
-e
if
[
"
$retval
"
-ne
"0"
]
;
then
if
[
"
$i
"
-lt
"3"
]
;
then
echo
"command '
$*
' failed in try
$i
, retrying after 60 seconds"
sleep
60
# let things settle a bit
else
echo
"command '
$*
' failed in try
$i
, giving up"
exit
$retval
fi
else
break
# success
fi
done
}
cd
"
$(
dirname
"
$0
"
)
"
/..
TF_LOG_PATH
=
terraform-init.log terraform init
TF_LOG_PATH
=
terraform-version.log terraform version
TF_LOG_PATH
=
terraform-workspace.log terraform workspace
new
"
$1
"
||
terraform workspace
select
"
$1
"
TF_LOG_PATH
=
terraform-destroy.log terraform destroy
-auto-approve
-var
=
"image_tag=dummy"
TF_LOG_PATH
=
terraform-workspace.log terraform workspace
select
-or-create
=
true
"
$1
"
TF_LOG_PATH
=
terraform-destroy.log
retry
terraform destroy
-auto-approve
-var
=
"image_tag=dummy"
TF_LOG_PATH
=
terraform-ws-default.log terraform workspace
select
default
TF_LOG_PATH
=
terraform-ws-delete.log terraform workspace delete
"
$1
"
This diff is collapsed.
Click to expand it.
Preview
0%
Loading
Try again
or
attach a new file
.
Cancel
You are about to add
0
people
to the discussion. Proceed with caution.
Finish editing this message first!
Save comment
Cancel
Please
register
or
sign in
to comment